clear all;
close all;
clc;

image=imread('sam_3.bmp');
figure,imshow(image),title('original');

sz=size(image);
height=sz(1);
width=sz(2);

sigma_s=0.03*min(height,width)
sigma_r=0.1;
sigma_t=0.1;
p=0.95;
w=0.95;
t0=0.25;
minAtmosLight=240;
beta=0.01;

% radius=floor(max(height,width)/50+0.5)
radius=10;
[X,Y]=meshgrid(-radius:radius,-radius:radius);
G=exp(-(X.^2+Y.^2)/2/sigma_s^2);

image_gray=rgb2gray(image);
% figure,imshow(image_gray),title('Gary image of original');

W=zeros(height,width);
for i=1:height
    for j=1:width
        W(i,j)=min(image(i,j,:));
    end
end
% figure,imshow(uint8(W)),title('W');
fprintf('W finished');

W_1=double(W)/255;
R=bilat_filter_grayscale2(W_1,radius,G,sigma_r);

% figure,imshow(R),title('R');
fprintf('R finished');

A=zeros(height,width);
A=medianFilter(W,radius);
B=A-median(abs(W-A),radius);
V=max(min(p*B,W),0);
fprintf('V finished');

ALight = min([minAtmosLight, max(max(255-W))])

V_R=bilat_filter_joint(V,R,G,radius,sigma_r);
fprintf('V_R finished');

% d=-log(1-V_R/ALight)./beta;
% figure,imshow(uint8(d)),title('depth from V_R');

% t=zeros(height,width);
t=ones(height,width)-w/ALight*V_R;
% t_depth=-log(t)./beta;
% figure,imshow(uint8(t_depth)),title('depth from t');

% image_gray1=double(image_gray);
% J=(image_gray1-ALight)./max(t,t0)+ALight;
image_double=double(image);
J=zeros(size(image));
J(:,:,1)=(image_double(:,:,1)-ALight)./max(t,t0)+ALight;
J(:,:,2)=(image_double(:,:,2)-ALight)./max(t,t0)+ALight;
J(:,:,3)=(image_double(:,:,3)-ALight)./max(t,t0)+ALight;
figure,imshow(uint8(J)),title('J');
% imwrite(J,'fog2_out.jpg','jpg');

% R_c=J(:,:,1);
% G_c=J(:,:,2);
% B_c=J(:,:,3);
% r_c=histeq(R_c);
% g_c=histeq(G_c);
% b_c=histeq(B_c);
% J_new=cat(3,r_c,g_c,b_c);
% figure,imshow(J_new),title('J\_new');