function [ out ] = bilat_filter_color( in,radius,sigma_s,sigma_r )
%   һɫͼ˫˲õԭʼķ

% if exist('applycform','file')  
%    in = applycform(in,makecform('srgb2lab'));  
% else  
%    in = colorspace('Lab<-RGB',in);  
% end  

[X,Y]=meshgrid(-radius:radius,-radius:radius);
G=exp(-(X.^2+Y.^2)/2/sigma_s^2);

% sigma_r=100*sigma_r;

h = waitbar(0,'Applying bilateral filter...');  
set(h,'Name','Bilateral Filter Progress');  

sz=size(in);
out=zeros(sz);
for i=1:sz(1)
    for j=1:sz(2)
        iMin = max(i-radius,1);  
        iMax = min(i+radius,sz(1));  
        jMin = max(j-radius,1);  
        jMax = min(j+radius,sz(2));  
        in_1 = in(iMin:iMax,jMin:jMax,:);  
        
        dL = in_1(:,:,1)-in(i,j,1);  
        da = in_1(:,:,2)-in(i,j,2);  
        db = in_1(:,:,3)-in(i,j,3);  
        H = exp(-(dL.^2+da.^2+db.^2)/(2*sigma_r^2));  
        
        F = H.*G((iMin:iMax)-i+radius+1,(jMin:jMax)-j+radius+1);  
        norm_F = sum(F(:));  
        out(i,j,1) = sum(sum(F.*in_1(:,:,1)))/norm_F;  
        out(i,j,2) = sum(sum(F.*in_1(:,:,2)))/norm_F;  
        out(i,j,3) = sum(sum(F.*in_1(:,:,3)))/norm_F;
    end  
   waitbar(i/sz(1));  
end  
  
% Convert filtered image back to sRGB color space.  
% if exist('applycform','file')  
%    out = applycform(out,makecform('lab2srgb'));  
% else    
%    out = colorspace('RGB<-Lab',out);  
% end  
  
% Close waitbar.  
close(h);  
end

