function [ out ] = bilat_filter_grayscale2( in,radius,G,sigma_r );
%  Gauss½˫˲Gظ

sz=size(in);
out=zeros(sz);
for i=1:sz(1)
    for j=1:sz(2)
        imin=max(i-radius,1);
        imax=min(i+radius,sz(1));
        jmin=max(j-radius,1);
        jmax=min(j+radius,sz(2));
        
        in_1=in(imin:imax,jmin:jmax);
        
        H=exp(-(in_1-in(i,j)).^2/2/sigma_r^2);
        
        F = H.*G((imin:imax)-i+radius+1,(jmin:jmax)-j+radius+1);  
        out(i,j) = sum(F(:).*in_1(:))/sum(F(:));  
    end
end
end


